summaryrefslogtreecommitdiff
path: root/plugins/bgnotify/bgnotify.plugin.zsh
diff options
context:
space:
mode:
authorDawid Ferenczy <dawid@ferenczy.cz>2015-08-25 16:34:04 +0200
committerDawid Ferenczy <dawid@ferenczy.cz>2015-08-25 16:34:04 +0200
commit18ef1ee6481dbeca4fbecf3de627f946860ffd5a (patch)
treecb07e72538c470bb486596d955c7912c5b05e23e /plugins/bgnotify/bgnotify.plugin.zsh
parenteafd5f325208421b82a770e57441dd1063eb5745 (diff)
parent192de6bcffb0294e19f4203f6f7dc1a7f3e427be (diff)
downloadzsh-18ef1ee6481dbeca4fbecf3de627f946860ffd5a.tar.gz
zsh-18ef1ee6481dbeca4fbecf3de627f946860ffd5a.tar.bz2
zsh-18ef1ee6481dbeca4fbecf3de627f946860ffd5a.zip
Merge remote-tracking branch 'robbyrussell/master'
Diffstat (limited to 'plugins/bgnotify/bgnotify.plugin.zsh')
-rwxr-xr-xplugins/bgnotify/bgnotify.plugin.zsh67
1 files changed, 67 insertions, 0 deletions
diff --git a/plugins/bgnotify/bgnotify.plugin.zsh b/plugins/bgnotify/bgnotify.plugin.zsh
new file mode 100755
index 000000000..b70b42f98
--- /dev/null
+++ b/plugins/bgnotify/bgnotify.plugin.zsh
@@ -0,0 +1,67 @@
+#!/usr/bin/env zsh
+
+## setup ##
+
+[[ -o interactive ]] || return #interactive only!
+zmodload zsh/datetime || { print "can't load zsh/datetime"; return } # faster than date()
+autoload -Uz add-zsh-hook || { print "can't add zsh hook!"; return }
+
+(( ${+bgnotify_threshold} )) || bgnotify_threshold=5 #default 10 seconds
+
+
+## definitions ##
+
+if ! (type bgnotify_formatted | grep -q 'function'); then
+ function bgnotify_formatted {
+ ## exit_status, command, elapsed_time
+ [ $1 -eq 0 ] && title="#win (took $3 s)" || title="#fail (took $3 s)"
+ bgnotify "$title" "$2"
+ }
+fi
+
+currentWindowId () {
+ if hash osascript 2>/dev/null; then #osx
+ osascript -e 'tell application (path to frontmost application as text) to id of front window' 2&> /dev/null || echo "0"
+ elif hash notify-send 2>/dev/null; then #ubuntu!
+ xprop -root | awk '/NET_ACTIVE_WINDOW/ { print $5; exit }'
+ else
+ echo $EPOCHSECONDS #fallback for windows
+ fi
+}
+
+bgnotify () {
+ if hash terminal-notifier 2>/dev/null; then #osx
+ terminal-notifier -message "$2" -title "$1"
+ elif hash growlnotify 2>/dev/null; then #osx growl
+ growlnotify -m "$1" "$2"
+ elif hash notify-send 2>/dev/null; then #ubuntu!
+ notify-send "$1" "$2"
+ elif hash notifu 2>/dev/null; then #cygwyn support!
+ notifu /m "$2" /p "$1"
+ fi
+}
+
+
+## Zsh hooks ##
+
+bgnotify_begin() {
+ bgnotify_timestamp=$EPOCHSECONDS
+ bgnotify_lastcmd=$1
+ bgnotify_windowid=$(currentWindowId)
+}
+
+bgnotify_end() {
+ didexit=$?
+ elapsed=$(( EPOCHSECONDS - bgnotify_timestamp ))
+ past_threshold=$(( elapsed >= bgnotify_threshold ))
+ if (( bgnotify_timestamp > 0 )) && (( past_threshold )); then
+ if [ $(currentWindowId) != "$bgnotify_windowid" ]; then
+ print -n "\a"
+ bgnotify_formatted "$didexit" "$bgnotify_lastcmd" "$elapsed"
+ fi
+ fi
+ bgnotify_timestamp=0 #reset it to 0!
+}
+
+add-zsh-hook preexec bgnotify_begin
+add-zsh-hook precmd bgnotify_end